	program bragg_analyt

	implicit none

	real maxdepth, v, norm_0, norm_1, pi, cyl_gauss, gamma_ln
	real p, alpha, q, beta, epsilon, sigma, gamma
	real depth_arr(10000), dose_arr(10000), dose_arr2(10000), maxdose
	real*8 depth
	integer i, nline

c_______Physical Parameters

c_______a: const.
	p = 1.77
	alpha = 0.0022
	q = 1.0
	beta = 0.012
	gamma = 0.6

c_______b: var.
c_______PSI:
cc	maxdepth = 21.0         ! = Range
cc	epsilon = 0.0
ccccc	sigma = 0.37
cc	sigma = 0.38
cc	norm_1 = 0.
c_______PSI_2:
cc	maxdepth = 13.6         ! = Range
cc	epsilon = 0.0
cccc	sigma = 0.26
cc	sigma = 0.266
cc	norm_1 = 0.
c_______TRIUMF_THEORET
cc	maxdepth = 20.6         ! = Range
ccccc	epsilon = 0.06
cc	epsilon = 0.0
ccccc	sigma = 0.23
cc	sigma = 0.203
cc	norm_1 = 0.
c_______Uppsala
cc	maxdepth = 23.4         ! = Range
cc	epsilon = 0.02
cc	sigma = 0.29
cc	norm_1 = 1.
c_______Test
cc	maxdepth = 15.64         ! = Range
cc	epsilon = 0.0
cc	sigma = 0.000000001	 ! sigma = 0.16
cc	norm_1 = 0.
c_______TRIUMF_70
cc	maxdepth = 3.17
cc	epsilon = 0.04
cc	sigma = 0.06
cc	norm_1 = 1.
c_______TRIUMF_70_NOZZLE
cc	maxdepth = 3.17
cc	epsilon = 0.09
cc	sigma = 0.06
cc	norm_1 = 1.
c_______TRIUMF_116
cc	maxdepth = 8.8
cc	epsilon = 0.0
cc	sigma = 0.13
cc	norm_1 = 1.
c_______TRIUMF_116_NOZZLE
cc	maxdepth = 8.8
cc	epsilon = 0.13
cc	sigma = 0.13
cc	norm_1 = 1.
c_______HARVARD
cc	maxdepth = 15.75
cc	epsilon = 0.05
cc	sigma = 0.27
cc	norm_1 = 77.
c_______HCL measured data
cc	maxdepth = 13.47
cc	epsilon = 0.20
cc	sigma = 0.27
cc	norm_1 = 1.
c_______80 MeV
ccccc	maxdepth = 5.14
cc	maxdepth = 5.0
cc	epsilon = 0.0
ccccc	sigma = 0.05545
cc	sigma = 0.025
cc	norm_1 = 0.0
c_______150 MeV
ccccc	maxdepth = 15.64
cc	maxdepth = 15.4
cc	epsilon = 0.0
ccccc	sigma = 0.157
cc	sigma = 0.12
cc	norm_1 = 0.0
c_______200 MeV
ccccc	maxdepth = 26.02
cc	maxdepth = 25.5
cc	epsilon = 0.0
ccccc	sigma = 0.2526
cc	sigma = 0.23
cc	norm_1 = 0.0
c_______200 MeV Uwe
cc	maxdepth = 26.2
cc	epsilon = 0.05
cc	sigma = 0.50
cc	norm_1 = 0.0
c_______250 MeV Uwe
cc	maxdepth = 38.3
cc	epsilon = 0.05
cc	sigma = 0.72
cc	norm_1 = 0.0
c-------120 Mev Oliver J
cc      maxdepth = 10.7
cc      epsilon =  0.
cc      sigma   = .20
cc      norm_1 = 0.0
c-------160 Mev Oliver J
        maxdepth = 17.63
        epsilon = 0.
c        sigma = .25
        sigma = .35
        norm_1 = 0.0

	pi = 3.1415927



	norm_0 = 1. / (alpha**(1./p)*(1.+beta*maxdepth**q))


cc	if (norm_1.ne.1.) then
cc	  norm_1 = norm_1 / 
cc	1   ( norm_0 * ( 1./p*maxdepth**(1./p-1.) + 
cc	1   (beta/p+gamma*q*beta+epsilon/maxdepth)*maxdepth**(1./p+q-1.) ) )
cc	endif



	nline = 0

	do depth = 0., maxdepth+10.*sigma, 0.015
cc	do depth = 0., maxdepth-0.01, 0.015
	  nline = nline + 1
	  depth_arr(nline) = depth
	  v = maxdepth - depth
cc	  dose_arr(nline) = norm_0 * ( 1./p*v**(1./p-1.) + 
cc	1	     (beta/p+gamma*q*beta+epsilon/maxdepth)*v**(1./p+q-1.) )
cc	  dose_arr2(nline) = 1./(1.+0.012*maxdepth)*
cc	1     ( 17.93*v**(-0.435) + (0.444+31.7*epsilon/maxdepth)*v**0.565 )

	  dose_arr(nline) =
	1	norm_0 / sqrt(2.*pi) 
	1	* ( 1./p*sigma**(1./p-1.)
	1	      *exp(gamma_ln(1./p))
	1	      *cyl_gauss(-1./p,-v/sigma) 
	1	   +(beta/p+gamma*q*beta+epsilon/maxdepth)*sigma**(1./p+q-1.)
	1	      *exp(gamma_ln(1./p+q))
	1	      *cyl_gauss(-1./p-q,-v/sigma) )

cc	  dose_arr2(nline) =
cc	1     sigma**0.565/(1.+0.012*maxdepth)*
cc	1	( 11.26/sigma*cyl_gauss(-0.565,-v/sigma) 
cc	1	  +(0.157+11.26*epsilon/maxdepth)*cyl_gauss(-1.565,-v/sigma) )

	enddo


c_______normalization
	if (norm_1.ne.0.0) then
	  maxdose = 0.0
	  do i = 1, nline
	    if(dose_arr(i).gt.maxdose) maxdose = dose_arr(i)
	  enddo
	  do i = 1, nline
	    dose_arr(i) = dose_arr(i) * norm_1/maxdose
	    dose_arr2(i) = dose_arr2(i) * norm_1/maxdose
	  enddo
	endif



	open(unit=10,file='bragg_analyt.dat',type='new',form='formatted')
	do i = 1,nline
cc	  write(10,*) depth_arr(i), dose_arr(i), dose_arr2(i)
          write(10,*) depth_arr(i), dose_arr(i)
	enddo
	close(unit=10)

	stop
	end
